package cn.axzo.msg.center.utils;

import cn.axzo.msg.center.common.template.TemplateParser;
import com.baomidou.mybatisplus.core.conditions.AbstractWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.conditions.AbstractChainWrapper;
import com.google.common.collect.ImmutableMap;
import org.apache.commons.lang3.StringUtils;

import java.util.Map;

/**
 * @author yanglin
 */
public class QueryFormatter {

    public static String format(AbstractChainWrapper<?, ?, ?, ?> wrapper) {
        return format(wrapper.getWrapper());
    }

    public static String format(AbstractWrapper<?, ?, ?> wrapper) {
        return formatImpl(wrapper);
    }

    private static String formatImpl(AbstractWrapper<?, ?, ?> wrapper) {
        AbstractWrapper<?, ?, ?> copy = wrapper.clone();
        String sql = copy.getSqlSegment();
        Map<String, Object> name2Values = copy.getParamNameValuePairs();
        if (StringUtils.isBlank(sql) || name2Values == null || name2Values.isEmpty())
            return sql;
        return TemplateParser.parseNumberSign(sql, ImmutableMap.of(Constants.WRAPPER, copy));
    }

}